//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::cmdOpenFileClick(TObject *Sender)
{
  OpenDialog1->Filter = "Supported Files (*.EXE, *.DLL)|*.EXE;*.DLL|Executable Files (*.EXE)|*.EXE|Dynamic Link Libraries (*.DLL)|*.DLL";
  OpenDialog1->FileName = "";

  if (OpenDialog1->Execute())
  {

    // Change the caption of the Application to show which file
    // is being looked at
    Caption = "Icon Extractor - " + OpenDialog1->FileName;
    Application->Title = Caption;
    lblCurrentFile->Caption = OpenDialog1->FileName;

    // Get the number of icons the file contains by passing -1 to
    // the Windows API call extracticon
    HICON numIcons = ExtractIcon(Handle,OpenDialog1->FileName.c_str(), -1);

    // Change label1 to show how many icons the file contains //
    lblCount->Caption = IntToStr((int)numIcons) + " icons found.";

    ImageList1->Clear();
    ListView1->Items->Clear();

    TListItem *li;
    TIcon *tempIcon;

    ListView1->Items->BeginUpdate();
    for (int i = 0; i < (int)numIcons; i++)
    {
      tempIcon = new TIcon();
      tempIcon->Handle = ExtractIcon(Handle,OpenDialog1->FileName.c_str(), i);
      li = ListView1->Items->Add();
      li->Caption = IntToStr(i);
      li->ImageIndex = ImageList1->AddIcon(tempIcon);
      delete tempIcon;
    }
    ListView1->Items->EndUpdate();

  }
  else
  {
    Caption = "Icon Extractor";
    Application->Title = Caption;
    lblCurrentFile->Caption = "No file selected.";
    lblCount->Caption = "0 icons found.";
    ImageList1->Clear();
    ListView1->Items->Clear();
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::ListView1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  pmnuSaveToICO->Enabled = ListView1->Selected != NULL;
  pmnuSaveToBitmap->Enabled = ListView1->Selected != NULL;
  pmnuCopyToClipboard->Enabled = ListView1->Selected != NULL;
  mnuSavetoIconFile1->Enabled = ListView1->Selected != NULL;
  mnuSavetoBitmap1->Enabled = ListView1->Selected != NULL;
  mnuCopytoClipboard1->Enabled = ListView1->Selected != NULL;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::pmnuSaveToICOClick(TObject *Sender)
{
  SaveDialog1->DefaultExt = "*.ICO";
  SaveDialog1->Filter = "Icon Files (*.ICO)|*.ICO";
  SaveDialog1->FileName = "";

  if (SaveDialog1->Execute())
  {
    TIcon *tempIcon = new TIcon();
    ImageList1->GetIcon(ListView1->Items->IndexOf(ListView1->Selected),tempIcon);
    tempIcon->SaveToFile(SaveDialog1->FileName);
    delete tempIcon;
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::pmnuSaveToBitmapClick(TObject *Sender)
{
  SaveDialog1->DefaultExt = "*.BMP";
  SaveDialog1->Filter = "Bitmap Files (*.BMP)|*.BMP";
  SaveDialog1->FileName = "";

  if (SaveDialog1->Execute())
  {
    Graphics::TBitmap *tempBitmap = new Graphics::TBitmap();
    ImageList1->GetBitmap(ListView1->Items->IndexOf(ListView1->Selected),tempBitmap);
    tempBitmap->SaveToFile(SaveDialog1->FileName);
    delete tempBitmap;
  }
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::pmnuCopyToClipboardClick(TObject *Sender)
{
  Graphics::TBitmap *tempBitmap = new Graphics::TBitmap();
  ImageList1->GetBitmap(ListView1->Items->IndexOf(ListView1->Selected),tempBitmap);
  Clipboard()->Assign(tempBitmap);
  delete tempBitmap;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::ListView1Resize(TObject *Sender)
{
  ListView1->Arrange(arDefault);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::mnuExitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

